; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; ADC initialisieren mit "Free Run" und Vorteiler								
; 	ADEN: ADC Enable                             								
; 	ADSC: ADC Start Conversion                   								
; 	ADFR: ADC Free Running Select                								
; 	ADIF: ADC Interrzpt Flag                     								
; 	ADIE: ADC Interrupt Enable                   								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
; 	ADPS2: Vorteiler                             								
;																				
;	ADPS2 ADPS1 ADPS0 Division Factor											
;	0 		0 	0 		2														
;	0 		0 	1 		2														
;	0 		1 	0 		4														
;	0 		1 	1 		8														
;	1 		0 	0 		16														
; *	1 		0 	1	 	32														
; 	1 		1 	0 		64														
;	1 		1 	1 		128														
;																					
; ADC REFERENZ																		
; REFS1 REFS0 Voltage Reference Selection											
;  0     0    AREF, Internal Vref turned off										
;  0     1    AVCC with external capacitor at AREF pin								
; *1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin	
;																					
; Sampling=VT*13/Takt																
;																					
AUDIO_ADC_INITIALISIERUNG:

	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADPS2)|(0<<ADPS1)|(1<<ADPS0)) 
	out ADCSR, temp

	ldi temp, (1<<REFS1)|(1<<REFS0)|(1<<ADLAR)|(0<<MUX3)|(1<<MUX2)|(0<<MUX1)|(1<<MUX0); ADC5
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
AUDIO_PLAY:
	rcall LCD_CLEAR
	rcall TEXT_PLAY
	rcall SEKTOR_NULL
	rcall SD_SEKTOR_READ_MULTIPLE_START
	rcall TASTEN_AKTIVIEREN
;-------------------------------------------------------------------------------
AUDIO_PLAY_s:
	WDR
	ldi temp1,(0xFE)				; auf  0xFE warten	
	rcall SPI_WAIT_TEMP1_C
	brcc AUDIO_PLAY_EXIT
	ldi ZL,low (512)
	ldi ZH,high(512)
;-------------------------------------------------------------------------------
AUDIO_PLAY_s1:
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp AUDIO_PLAY_s1
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
;-------------------------------------------------------------------------------
	rcall SPI_RX_TEMP
	OUT PWM,temp
;-------------------------------------------------------------------------------
	sbiw ZL,1
	tst ZH
	brne AUDIO_PLAY_s1
	tst ZL
	brne AUDIO_PLAY_s1
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	rjmp AUDIO_PLAY_EXIT
	rjmp AUDIO_PLAY_s
;-------------------------------------------------------------------------------
AUDIO_PLAY_EXIT:
	rcall SD_SEKTOR_READ_MULTIPLE_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
AUDIO_AUFNAHME:
	rcall LCD_CLEAR
	rcall TEXT_AUFNAHME
	rcall SEKTOR_NULL
	rcall SD_SEKTOR_WRITE_MULTIPLE_START
	rcall TASTEN_AKTIVIEREN
;-------------------------------------------------------------------------------
AUDIO_AUFNAHME_s:
	WDR
	ldi temp,0b11111100				; Start Block Token senden		
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP		
	ldi ZL,low (512)
	ldi ZH,high(512)
;-------------------------------------------------------------------------------
AUDIO_AUFNAHME_s1:
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp AUDIO_AUFNAHME_s1
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
	in  temp, ADCH 				; ADC							
	OUT PWM,temp
	rcall SPI_TX_RX_TEMP
;-------------------------------------------------------------------------------
	sbiw ZL,1					; -1
	tst ZH
	brne AUDIO_AUFNAHME_s1
	tst ZL
	brne AUDIO_AUFNAHME_s1
;-------------------------------------------------------------------------------
	ldi temp1,(0xE5)				; auf  0xE5 warten
	rcall SPI_WAIT_TEMP1_C
	brcc AUDIO_AUFNAHME_EXIT
	ldi temp1,(0xFF)				; auf  0xFF warten	
	rcall SPI_WAIT_TEMP1_C
	brcc AUDIO_AUFNAHME_EXIT
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	rjmp AUDIO_AUFNAHME_EXIT
	rjmp AUDIO_AUFNAHME_s
;-------------------------------------------------------------------------------
AUDIO_AUFNAHME_EXIT:
	rcall SD_SEKTOR_WRITE_MULTIPLE_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
AUDIO_DIREKT:
	rcall TASTEN_AKTIVIEREN
;-------------------------------------------------------------------------------
AUDIO_DIREKT_s:
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp AUDIO_DIREKT_s
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
	WDR
	in  temp, ADCH 				; ADC							
	OUT PWM,temp
	; Taste "B"gedrckt ?		
	sbis (TASTE_B_PIN),(TASTE_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	rjmp AUDIO_DIREKT_EXIT
	rjmp AUDIO_DIREKT_s
;-------------------------------------------------------------------------------
AUDIO_DIREKT_EXIT:
	rcall LCD_CLEAR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################


