; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; LCD 2x16 4x16 4x20 ZEICHEN													
;																				
; LCD-INITIALISIERUNG															
LCD_INITIALISIERUNG:
	; auf LOW				
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
	cbi (LCD_EN_PORT),(LCD_EN)
	cbi (LCD_RS_PORT),(LCD_RS)
	; auf Ausgang			
	sbi (LCD_DATA0_DDR),(LCD_DATA0)
	sbi (LCD_DATA1_DDR),(LCD_DATA1)
	sbi (LCD_DATA2_DDR),(LCD_DATA2)
	sbi (LCD_DATA3_DDR),(LCD_DATA3)
	sbi (LCD_RS_DDR),(LCD_RS)
	sbi (LCD_EN_DDR),(LCD_EN)
	; INITIALISIERUNG		
    cbi (LCD_RS_PORT),(LCD_RS)	; RS aus (low)				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)  	; x03 muss 3mal hintereinander gesendet werden zur Initialisierun
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	rcall LCD_ENABLE					; 1	
	rcall LCD_ENABLE					; 2	
	rcall LCD_ENABLE					; 3	
    ldi temp, 0b00000010        ;4bit-Modus einstellen		
 	rcall LCD_COMMAND_TEMP
    ldi temp, 0b00000001        ; DISPLAY lschen			
 	rcall LCD_COMMAND_TEMP
    ldi temp, 0b00001111        ; DISPLAY ein / CURSOR blinken
 	rcall LCD_COMMAND_TEMP
    ldi temp, 0b00000110        ; Cursor Auto-Increment		
 	rcall LCD_COMMAND_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; sendet ein Datenbyte an das LCD										  		
LCD_DATA_TEMP:
	sbi (LCD_RS_PORT),(LCD_RS)			; RS=H 	
	rjmp LCD_DATA_RUN
LCD_DATA_RS:
    cbi (LCD_RS_PORT),(LCD_RS) 			; RS=L	
;-------------------------------------------------------------------------------
LCD_DATA_RUN:
	sbi (LCD_DATA0_DDR),(LCD_DATA0)		; auf Ausgang				
	sbi (LCD_DATA1_DDR),(LCD_DATA1)
	sbi (LCD_DATA2_DDR),(LCD_DATA2)
	sbi (LCD_DATA3_DDR),(LCD_DATA3)

	SBRS temp,4							; SPRUNG, wenn BIT set		
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRS temp,5		
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRS temp,6		
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRS temp,7	
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,4							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,5
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,6
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,7
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall LCD_ENABLE        				; Enable	
;-------------------------------------------------------------------------------
	SBRS temp,0							; SPRUNG, wenn BIT set		
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRS temp,1		
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRS temp,2		
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRS temp,3		
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,0							; SPRUNG, wenn BIT clear	
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,1
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,2
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,3
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall LCD_ENABLE        				; Enable	
ret				                       
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_COMMAND_TEMP:                            
	rcall LCD_DATA_RS
	rjmp wait_5ms						;5 Pause (wichtig)				
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_ENABLE:
 	rcall wait_20us            		  	;5 kurze PAUSE		
	sbi LCD_EN_PORT, LCD_EN    		   	; Enable high		
 	rcall wait_20us            		  	; kurze PAUSE		
	cbi LCD_EN_PORT, LCD_EN     	  	; Enable low		
ret 
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Text aus Tabelle																
ANZEIGE_TEXT_Z:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	brne ANZEIGE_TEXT_w
	ret
ANZEIGE_TEXT_w:
	rcall LCD_DATA_TEMP			; Anzeige
	rjmp ANZEIGE_TEXT_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_CLEAR:
   	ldi temp, 0b00000001
 	rcall LCD_COMMAND_TEMP
	rjmp ZEILE1
;-------------------------------------------------------------------------------
ZEILE1:
 	ldi temp, 0b00000010
	rjmp LCD_COMMAND_TEMP
;-------------------------------------------------------------------------------
ZEILE2:
 	ldi temp, 0b11000000 
	rjmp LCD_COMMAND_TEMP
;-------------------------------------------------------------------------------
ZEILE3:
;	ldi temp, 0b10010000 	; LCD 4x16	
 	ldi temp, 0b10010100  	; LCD 4x20
	rjmp LCD_COMMAND_TEMP
;-------------------------------------------------------------------------------
ZEILE4:
;	ldi temp, 0b11010000 	; LCD 4x16	
	ldi temp, 0b11010100	; LCD 4x20
	rjmp LCD_COMMAND_TEMP
