; CMD0 None(0) R1 No GO_IDLE_STATE Software reset. 
; CMD1 None(0) R1 No SEND_OP_COND Initiate initialization process. 
; ACMD41(*1) *2 R1 No APP_SEND_OP_COND For only SDC. Initiate initialization process. 
; CMD8 *3 R7 No SEND_IF_COND For only SDC V2. Check voltage range. 
; CMD9 None(0) R1 Yes SEND_CSD Read CSD register. 
; CMD10 None(0) R1 Yes SEND_CID Read CID register. 
; CMD12 None(0) R1b No STOP_TRANSMISSION Stop to read data. 
; CMD16 Block length[31:0] R1 No SET_BLOCKLEN Change R/W block size. 
; CMD17 Address[31:0] R1 Yes READ_SINGLE_BLOCK Read a block. 
; CMD18 Address[31:0] R1 Yes READ_MULTIPLE_BLOCK Read multiple blocks. 
; CMD23 Number of blocks[15:0] R1 No SET_BLOCK_COUNT For only MMC. Define number of blocks to transfer with next multi-block read/write command. 
; ACMD23(*1) Number of blocks[22:0] R1 No SET_WR_BLOCK_ERASE_COUNT For only SDC. Define number of blocks to pre-erasewith next multi-block write command. 
; CMD24 Address[31:0] R1 Yes WRITE_BLOCK Write a block. 
; CMD25 Address[31:0] R1 Yes WRITE_MULTIPLE_BLOCK Write multiple blocks. 
; CMD55(*1) None(0) R1 No APP_CMD Leading command of ACMD<n> command. 
; CMD58 None(0) R3 No READ_OCR Read OCR. 										

;OCR, CID, CSD, RCA, DSR and SCR

; 																				
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CHECK:
	rcall SD_READ_STATUS					; read !	
	tst ERROR
	breq SD_CHECK_OK
	rcall SD_READ_STATUS					; read !	
	tst ERROR
	breq SD_CHECK_OK
	rjmp SD_INITIALISIERUNG					; Initialisierung	
;-------------------------------------------------------------------------------
SD_CHECK_OK:
	LED_GRUEN_ON
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_INITIALISIERUNG:
	LED_ROT_ON
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG_START:
	LED_GRUEN_OFF
	clr ERROR
	rcall SD_DATA_CLEAR						; CLEAR		
	STS(adr_SD_SDHC_AKTIV),NULL
	STS(adr_SD_MDT),NULL
	STS(adr_SD_PNM1),NULL
	STS(adr_SD_PNM2),NULL
	STS(adr_SD_PNM3),NULL
	STS(adr_SD_PNM4),NULL
	STS(adr_SD_PNM5),NULL
	STS(adr_SD_PSN0),NULL
	STS(adr_SD_PSN1),NULL
	STS(adr_SD_PSN2),NULL
	STS(adr_SD_PSN3),NULL
	STS(adr_SD_SEKTOR_MAX0),NULL
	STS(adr_SD_SEKTOR_MAX1),NULL
	STS(adr_SD_SEKTOR_MAX2),NULL
	STS(adr_SD_SEKTOR_MAX3),NULL
	STS(adr_SD_CAPACITY_MB0),NULL
	STS(adr_SD_CAPACITY_MB1),NULL
	STS(adr_SD_CAPACITY_MB2),NULL
	STS(adr_SD_CAPACITY_MB3),NULL
	rcall SPI_TAKT_LOW						; TAKT		
;-------------------------------------------------------------------------------
	rcall SD_CMD0							; RESET		
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD
	LED_ROT_OFF
;-------------------------------------------------------------------------------
	rcall LCD_CLEAR
	rcall TEXT_SD
	rcall ASCII_PUNKT
	rcall SD_CMD8
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_ACMD41
	tst ERROR
	breq SD_INITIALISIERUNG_RUN
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_CMD1
	tst ERROR
	breq SD_INITIALISIERUNG_RUN
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG_NO_CARD:
	LED_GRUEN_OFF
	LED_ROT_ON
	rcall LCD_CLEAR
	rcall TEXT_NO_SD
	clr ERROR								; ERROR NULL
	rjmp WAIT_500ms
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
SD_INITIALISIERUNG_RUN:
	LED_GRUEN_ON
;	rcall SPI_TAKT_HIGH						; Takt		
	rcall SPI_TAKT_SUPER_HIGH				; Takt		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_READ_STATUS					; STATUS 	
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_SET_BLOCKLEN					; Blocklnge setzen (512Byte)
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_OCR_READ
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	LDS temp,(adr_SD_SDHC_AKTIV)
	tst temp
	breq SD_INI_w
	rcall TEXT_SDHC							; SDHC		
	rcall WAIT_1s
SD_INI_w:
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_CID_READ						; REGISTER CID	(card identification)	
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_CSD_READ						; REGISTER CSD  (Card Specific Data)	
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_CSD_CALC						; REGISTER CSD 
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SD_READ_STATUS					; STATUS	
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SEKTOR_NULL						; NULL		
	rcall SD_SEKTOR_READ
	tst ERROR
	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	LDS SEKTOR0,(adr_SD_SEKTOR_MAX0)		; MAX		
	LDS SEKTOR1,(adr_SD_SEKTOR_MAX1)
	LDS SEKTOR2,(adr_SD_SEKTOR_MAX2)
	LDS SEKTOR3,(adr_SD_SEKTOR_MAX3)
;	rcall SD_SEKTOR_READ
;	tst ERROR
;	brne SD_INITIALISIERUNG_NO_CARD			; ERROR		
;-------------------------------------------------------------------------------
	rcall ASCII_PUNKT
	rcall SEKTOR_NULL						; NULL		
	ldi ZL,LOW (100)	
	ldi ZH,high(100)
SD_INI_s:
	rcall SD_SEKTOR_READ
	rcall SEKTOR_PLUS_EINS
	tst ERROR
	breq SD_INI_sw
	rjmp SD_INITIALISIERUNG_NO_CARD			; ERROR		
SD_INI_sw:
	sbiw ZL,1
	tst ZL
	brne SD_INI_s
	tst ZH
	brne SD_INI_s
;-------------------------------------------------------------------------------
	rcall LCD_CLEAR
	rcall BEEP_KURZ
	rcall BEEP_KURZ
	rjmp SD_CHECK
; ##############################################################################
; ##############################################################################
; ##############################################################################
; IDLE MODUS versetzen															
; software reset command														
; CRC muss bei CMD0 und CMD8 korrekt sein !										
; Send: 0x40 0x00 0x00 0x00 0x00 0x95 (CMD0)									
; Recv: 0x01 (R1-Antwort mit dem "In Idle State"-Bit gesetzt.)					
; (CMD0) 																		
SD_CMD0:
	rcall SPI_CS_HIGH		; CS auf HIGH				
	rcall SPI_CLEAR_HIGH	; mindestens 74 CLOCKS senden, CS und MOSI auf HIGH		
; ------------------------------------------------------------------------------
	ldi temp9,10			; 3 Anzahl (wenn Wert zu gro, dann lange Wartezeit)
SD_CMD0_s1:
	ldi temp1, 0x40+0		; CMD0	
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x95
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP		; OUT: temp					
	cpi temp,0x01			; auf  0x01 warten			
	breq SD_CMD0_OK
	rcall WAIT_1ms			; PAUSE						
	rcall SPI_CLEAR_HIGH
	dec temp9
	brne SD_CMD0_s1
	rjmp SD_CMD0_ERROR
; ------------------------------------------------------------------------------
SD_CMD0_OK:
	rcall SPI_CLEAR_HIGH
	ret
; ------------------------------------------------------------------------------
SD_CMD0_ERROR:
	mov ERROR,VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Nun muss die Karte in den Betriebsmodus versetzt werden.						
; CMD1 funktioniert bei allen MMCs und allen "dicken\ SDKarten.					
; Fur die dunnen (1,4mm) SD-Karten ist CMD1 ein illegales Kommando.			
; Send: 0x41 0x00 0x00 0x00 0x00 0x01 (CMD1)									
; Recv: 0x00 (R1-Antwort, jetzt ohne "In Idle State")							
; (CMD1) 																		
SD_CMD1:
	ldi temp9,10			; Anzahl (wenn Wert zu gro, dann lange Wartezeit)
SD_CMD1_s:
	ldi temp1, 0x40+1		; CMD1
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP		; OUT: temp
	cpi temp,0x00				; auf  0x00 warten			
	breq SD_CMD1_OK
	rcall SPI_CLEAR_HIGH
	dec temp9
	brne SD_CMD1_s
	rjmp SD_CMD1_ERROR
; ------------------------------------------------------------------------------
SD_CMD1_OK:
	rcall SPI_CLEAR_HIGH
	ret
; ------------------------------------------------------------------------------
SD_CMD1_ERROR:
	mov ERROR,VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD8 wird nur zum Initialisieren von SDHC-Karten mit							
; einer Kapazitt von 4GB und mehr gebraucht									
; CRC muss bei CMD0 und CMD8 korrekt sein !										
;- Voltage check																
;- Enabling expansion of existing command and response							
; Send: 0x48 0x00 0x00 0x01 0xAA 0x87 											
; Recv: 0x01 0x00 0x00 0x01 0xAA												
; (CMD8) 																		
SD_CMD8:	
	ldi temp1, 0x40+8				; CMD8							
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x01					; Voltage supplied (VHS) 2.7-3.6V
	ldi temp5, 0xAA					; Check pattern (Prfmuster)	
	ldi temp6, 0x87
	rcall SD_TX_KOMMANDO_TEMP1_6 	; INP:temp1...6 OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
	rcall SPI_RX_TEMP				; OUT: temp
;	cpi temp,0xAA
;	breq SD_CMD8_OK
;	rjmp SD_CMD8_ERROR
; ------------------------------------------------------------------------------
SD_CMD8_OK:
	rcall SPI_CLEAR_HIGH
ret
; ------------------------------------------------------------------------------
SD_CMD8_ERROR:
	rcall SPI_CLEAR_HIGH
	mov ERROR,VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Nun muss die Karte in den Betriebsmodus versetzt werden.						
; Send: 0x77 0x00 0x00 0x00 0x00 0x01 (CMD55, das "Prefix" fr ein ACMD)		
; Recv: 0x01 (R1-noch "In Idle State")											
; Send: 0x69 0x00 0x00 0x00 0x00 0x01 (ACMD41)									
; Recv: 0x01 (R1-noch "In Idle State")											
; ....																			
; Send: 0x77 0x00 0x00 0x00 0x00 0x01											
; Recv: 0x01 oder 0x00															
; Send: 0x69 0x00 0x00 0x00 0x00 0x01											
; Recv: 0x00 (R1-Antwort, jetzt ohne "In Idle State")							
; (ACMD41) 																		
SD_ACMD41:
	ldi temp9,10			; Anzahl (wenn Wert zu gro, dann lange Wartezeit)
SD_ACMD41_s:
	rcall SD_CMD55_PREFIX_ACMD
	ldi temp1, 0x69
	ldi temp2, 0x40 ;0x00 nur SDSC // 0x40 SDSC und SDHC
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP		; OUT: temp
	cpi temp, 0x00
	breq SD_ACMD41_OK
	rcall SPI_CLEAR_HIGH
	dec temp9
	brne SD_ACMD41_s
	rjmp SD_ACMD41_ERROR
; ------------------------------------------------------------------------------
SD_ACMD41_OK:
	rcall SPI_CLEAR_HIGH
	ret
; ------------------------------------------------------------------------------
SD_ACMD41_ERROR:
	rcall SPI_CLEAR_HIGH
	mov ERROR,VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CMD55 das "Prefix" fr ein ACMD												
SD_CMD55_PREFIX_ACMD:
	ldi temp1, 0x77
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x01
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_CLEAR_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CSD - Register auslesen (Card Specific Data)									
; max. data transfer rate (TRAN_SPEED)  32h, 5Ah, 0Bh or 2Bh [103:96] 8 Bit		
; "CSD_STRUCTURE" herausfiltern	[127:126]										
; "C_SIZE" herausfiltern [69:48] 22bit											
; "READ_BL_LEN" herausfiltern [83:80] 4Bit										
; "C_SIZE" herausfiltern [73:62] 12Bit											
; "C_SIZE_MULT" herausfiltern [49:47] 											
; (CMD9)																		
SD_CSD_READ:
	rcall SD_DATA_CLEAR			; CLEAR
	rcall SD_READ_STATUS
	tst ERROR
	breq SD_CSD_READ_RUN
	ret
; ------------------------------------------------------------------------------
SD_CSD_READ_RUN:
	ldi temp1, 0x40+9			; CMD9	  0x49, 0x00, 0x00, 0x00, 0x00, 0x00
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp	
; ------------------------------------------------------------------------------
	ldi temp1,(0xFE)				; auf  0xFE warten
	rcall SPI_WAIT_TEMP1_C
	brcs SD_CMD9_OK
	rjmp SD_CMD9_ERROR
; ------------------------------------------------------------------------------
SD_CMD9_OK:
	rcall SPI_RX512_DATA
	rjmp SPI_WAIT_FF_HIGH
; ------------------------------------------------------------------------------
SD_CMD9_ERROR:
	mov ERROR,VOLL
	rjmp SPI_CLEAR_HIGH
; ##############################################################################
; ##############################################################################
; ##############################################################################
;Bit 31 - Card power up status bit, this status bit is set if the card power up procedure has been finished.
;Bit 30 - Card Capacity Status bit, 											
;		0 indicates that the card is SDSC. 										
;		1 indicates that the card is SDHC or SDXC. 								
;		The Card Capacity Status bit is valid after the card power up procedure is completed and the card power up status bit is set to 1. The Host shall read this status bit to identify SDSC Card or SDHC/SDXC Card.
; (CMD58)																		
SD_OCR_READ:
	rcall SD_DATA_CLEAR			; CLEAR
	rcall SD_READ_STATUS
	tst ERROR
	breq SD_OCR_READ_RUN
	ret
; ------------------------------------------------------------------------------
SD_OCR_READ_RUN:
	ldi temp1, 0x40+58			
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp	
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP			; OUT: temp
	cpi temp,0x00
	brne SD_OCR_ERROR
; ------------------------------------------------------------------------------
	rcall SPI_RX512_DATA
	LDS temp,(adr_SD_DATA+0)
	andi temp,0b01000000		; SDSC/SDHC
	STS(adr_SD_SDHC_AKTIV),temp
	rjmp SPI_WAIT_FF_HIGH
; ------------------------------------------------------------------------------
SD_OCR_ERROR:
	mov ERROR,VOLL
	rjmp SPI_CLEAR_HIGH
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CID - Register auslesen (card identification)									
; Manufacturer ID MID 8 [127:120]												
; Product name PNM [103:64] 40													
; Product serial number PSN [55:24] 32											
; Manufacturing date MDT [19:8] 12												
; Manufacturing date MDT [19:8] 12												
; (CMD10)																		
SD_CID_READ:
	rcall SD_DATA_CLEAR			; CLEAR
	rcall SD_READ_STATUS
	tst ERROR
	breq SD_CID_READ_RUN
	ret
; ------------------------------------------------------------------------------
SD_CID_READ_RUN:
	ldi temp1, 0x40+10			; CMD10
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	ldi temp1,(0xFE)				; auf  0xFE warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_CID_ERROR
; ------------------------------------------------------------------------------
	rcall SPI_RX512_DATA
	rcall SPI_WAIT_FF_HIGH

	LDS temp,(adr_SD_DATA+3)	; Produkt NAME
	STS(adr_SD_PNM1),temp
	LDS temp,(adr_SD_DATA+4)
	STS(adr_SD_PNM2),temp
	LDS temp,(adr_SD_DATA+5)
	STS(adr_SD_PNM3),temp
	LDS temp,(adr_SD_DATA+6)
	STS(adr_SD_PNM4),temp
	LDS temp,(adr_SD_DATA+7)
	STS(adr_SD_PNM5),temp

	LDS temp,(adr_SD_DATA+9)
	STS(adr_SD_PSN0),temp
	LDS temp,(adr_SD_DATA+10)
	STS(adr_SD_PSN1),temp
	LDS temp,(adr_SD_DATA+11)
	STS(adr_SD_PSN2),temp
	LDS temp,(adr_SD_DATA+12)
	STS(adr_SD_PSN3),temp

	LDS temp2,(adr_SD_DATA+13)
	andi temp2,0b00001111		; reservierte Bits ignorieren	
	LDS temp1,(adr_SD_DATA+14)
	LSR TEMP2					; rechts	
	ROR TEMP1
	LSR TEMP2					; rechts	
	ROR TEMP1
	LSR TEMP2					; rechts	
	ROR TEMP1
	LSR TEMP2					; rechts	
	ROR TEMP1
	STS(adr_SD_MDT),temp1		; Jahr		
ret
; ------------------------------------------------------------------------------
SD_CID_ERROR:
	rcall SPI_CLEAR_HIGH
	ldi temp,(ERROR_SD_CID)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Addressed card sends its status register.										
; (CMD13)																		
SD_READ_STATUS:
	ldi temp1, 0x40+13			; CMD13 (SEND_STATUS)
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP
	mov temp1,temp
	rcall SPI_RX_TEMP
	mov temp2,temp
	rcall SPI_RX_TEMP
	mov temp3,temp
	rcall SPI_CS_HIGH			; CS high
	; Auswertung				
	cpi temp1,(0x00)
	brne SD_STATUS_READ_ERROR
	cpi temp2,(0x00)
	brne SD_STATUS_READ_ERROR
	cpi temp3,(0xFF)
	brne SD_STATUS_READ_ERROR
; ------------------------------------------------------------------------------
	clr ERROR
	ret
; ------------------------------------------------------------------------------
SD_STATUS_READ_ERROR:
	rcall SPI_CLEAR_HIGH
	ldi temp,(ERROR_SD_STATUS)
	mov ERROR,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Sends an addressed card into the Inactive State.								
; (CMD15)																		
SD_CMD15:
	ldi temp1, 0x40+15			
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x00
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_WAIT_FF_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Blocklnge setzen (512Byte)													
; (CMD16)																		
SD_SET_BLOCKLEN:
	ldi temp1, 0x40+16
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x02					; 02
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	rcall SPI_RX_TEMP			; OUT: temp			
	cpi temp,0x00				; auf  0x00 warten	
	breq SD_CMD16_OK
	rjmp SD_CMD16_ERROR
; ------------------------------------------------------------------------------
SD_CMD16_OK:
	rcall SPI_WAIT_FF_HIGH
	clr ERROR
	ret
; ------------------------------------------------------------------------------
SD_CMD16_ERROR:
	rcall SPI_CLEAR_HIGH
	mov ERROR,VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; http://elm-chan.org/docs/mmc/mmc_e.html										
; Reads a block of the size selected by the SET_BLOCKLEN command				
; 512 BYTES einlesen															
; INP: SEKTOR0...3																
; (CMD17)																		
SD_SEKTOR_READ:
	tst ERROR
	breq SD_SEKTOR_READ_START
	ret
; ------------------------------------------------------------------------------
SD_SEKTOR_READ_START:
	ldi temp1, 0x51
	ldi temp6, 0x00
	rcall SD_SET_PHYS_ADRESSE			; Umrechnung auf phys. Adresse	
	rcall SD_TX_KOMMANDO_TEMP1_6 		; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	ldi temp1,(0xFE)					; auf  0xFE warten		
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_READ_ERROR
; ------------------------------------------------------------------------------
	rcall SPI_RX512_DATA				; read DATA				
	rjmp SPI_WAIT_FF_HIGH				; auf  0xFF warten		
; ------------------------------------------------------------------------------
SD_SEKTOR_READ_ERROR:
	rcall SPI_CLEAR_HIGH
	LED_ROT_ON
	ldi temp,(ERROR_SD_READ)
	mov ERROR,temp
	rcall ANZEIGE_ERROR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 512 BYTES write																
; INP: SEKTOR																	
; OUT: ERROR																	
; (CMD24)																		
SD_SEKTOR_WRITE:
	ldi temp1, 0x40+24					; CMD24		
	ldi temp6, 0x00
	rcall SD_SET_PHYS_ADRESSE			; Umrechnung auf phys. Adresse	
	rcall SD_TX_KOMMANDO_TEMP1_6 		; INP:temp1...6 OUT: temp	
; ------------------------------------------------------------------------------
	ldi temp1,(0x00)					; auf  0x00 warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_WRITE_ERROR_A
; ------------------------------------------------------------------------------
	ldi temp,0xFE						; xFE senden		
	rcall SPI_TX_RX_TEMP				; INP/OUT: TEMP		
	rcall SPI_TX512_DATA				; 512 Bytes senden	
; ------------------------------------------------------------------------------
	ldi temp1,(0xE5)					; auf  0xE5 warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_WRITE_ERROR_B
; ------------------------------------------------------------------------------
	ldi temp1,(0xFF)					; auf  0xFF warten	
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_WRITE_ERROR_C
	rjmp SPI_WAIT_FF_HIGH				; auf  0xFF warten	
; ------------------------------------------------------------------------------
SD_SEKTOR_WRITE_ERROR_A:
	LED_ROT_ON
	ldi temp,(ERROR_SD_WRITE_A)
	mov ERROR,temp
	rjmp ANZEIGE_ERROR
; ------------------------------------------------------------------------------
SD_SEKTOR_WRITE_ERROR_B:
	LED_ROT_ON
	ldi temp,(ERROR_SD_WRITE_B)
	mov ERROR,temp
	rjmp ANZEIGE_ERROR
; ------------------------------------------------------------------------------
SD_SEKTOR_WRITE_ERROR_C:
	rcall SPI_CLEAR_HIGH
	LED_ROT_ON
	ldi temp,(ERROR_SD_WRITE_C)
	mov ERROR,temp
	rjmp ANZEIGE_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
; http://elm-chan.org/docs/mmc/mmc_e.html										
; Continuously transfers data blocks from card to host until interrupted by a STOP_TRANSMISSION command.
; CMD18- READ_MULTIPLE_BLOCK															
; INP: SD_SEKTOR																
; START + DATA... + STOP														
SD_SEKTOR_READ_MULTIPLE_START:
	ldi temp1, 0x40+18				; CMD18	
	ldi temp6, 0x00
	rcall SD_SET_PHYS_ADRESSE		; Umrechnung auf phys. Adresse	
	rjmp SD_TX_KOMMANDO_TEMP1_6 	; INP:temp1...6 OUT: temp		
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_SEKTOR_READ_MULTIPLE_DATA:
	ldi temp1,(0xFE)				; auf  0xFE warten	
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_READ_MULTIPLE_ERROR
	rjmp SPI_RX512_DATA				; read DATA			
; ------------------------------------------------------------------------------
SD_SEKTOR_READ_MULTIPLE_ERROR:
	LED_ROT_ON
	ldi temp,(ERROR_SD_READ_MULTIPLE)
	mov ERROR,temp
	rcall ANZEIGE_ERROR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Stop to read data																
; (CMD12)																		
SD_SEKTOR_READ_MULTIPLE_STOP:
	ldi temp1, 0x40+12
	ldi temp2, 0x00
	ldi temp3, 0x00
	ldi temp4, 0x02
	ldi temp5, 0x00
	ldi temp6, 0x00
	rcall SD_TX_KOMMANDO_TEMP1_6 ; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	ldi temp1,(0x00)				; auf  0x00 warten	
	rcall SPI_WAIT_TEMP1_C
	rcall SPI_CLEAR_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; (CMD25)																		
; INP: SD_SEKTOR																
; OUT: ERROR																	
SD_SEKTOR_WRITE_MULTIPLE_START:
	ldi temp1, 0x40+25				; CMD25	
	ldi temp6, 0x00
	rcall SD_SET_PHYS_ADRESSE		; Umrechnung auf phys. Adresse	
	rcall SD_TX_KOMMANDO_TEMP1_6 	; INP:temp1...6 OUT: temp
; ------------------------------------------------------------------------------
	ldi temp1,(0x00)				; auf  0x00 warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_WRITE_MULTIPLE_ERROR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_SEKTOR_WRITE_MULTIPLE_DATA:
	ldi temp,0b11111100				; Start Block Token senden		
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP		
	rcall SPI_TX512_DATA			; 512 Bytes senden	
	ldi temp1,(0xE5)				; auf  0xE5 warten
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_WRITE_MULTIPLE_ERROR
	ldi temp1,(0xFF)				; auf  0xFF warten	
	rcall SPI_WAIT_TEMP1_C
	brcc SD_SEKTOR_WRITE_MULTIPLE_ERROR
ret
; ------------------------------------------------------------------------------
SD_SEKTOR_WRITE_MULTIPLE_ERROR:
	LED_ROT_ON
	ldi temp,(ERROR_SD_WRITE_MULTIPLE)
	mov ERROR,temp
	rcall ANZEIGE_ERROR
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_SEKTOR_WRITE_MULTIPLE_STOP:
	ldi temp,0b11111101				; STOP Block Token senden	
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP		
	rcall SPI_WAIT_FF_HIGH
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: SD_SEKTOR																
; OUT: temp2+3+4+5																
SD_SET_PHYS_ADRESSE:
	LDS temp,(adr_SD_SDHC_AKTIV)
	tst temp
	breq SD_SET_PHYS_SDSC
; ------------------------------------------------------------------------------
	mov temp2,SEKTOR3
	mov temp3,SEKTOR2	
	mov temp4,SEKTOR1	
	mov temp5,SEKTOR0	
	ret
; ------------------------------------------------------------------------------
; Umrechnen von SEKTOR in physikalische ADRESSE	 (mal 512 (9xlinks))			
SD_SET_PHYS_SDSC:
	mov temp2,SEKTOR2		; 8xlinks		
	mov temp3,SEKTOR1	
	mov temp4,SEKTOR0	
	clr temp5				; LOW			
	LSL temp5				; LOW 1xlinks	
	ROL temp4
	ROL temp3
	ROL temp2				; HIGH			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; INP: temp1...6																
;																				
SD_TX_KOMMANDO_TEMP1_6:
	rcall SPI_CS_LOW				; CS auf LOW !!		
	mov temp,temp1					; temp1...6 senden	
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp2
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp3
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp4
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp5
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	mov temp,temp6
	rcall SPI_TX_RX_TEMP			; INP/OUT: TEMP
	; DUMMY					
	rcall SPI_RX_TEMP			; OUT: temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_DATA_CLEAR:
	push ZL
	push ZH
	ldi ZL, LOW(adr_SD_DATA)	; Z-ZEIGER initialisieren	
	ldi ZH,HIGH(adr_SD_DATA)
	ldi temp9,16				; Schleife (32x16=512)		
SD_DATA_CLEAR_s:
	ST Z+,NULL	; 0
	ST Z+,NULL	; 1
	ST Z+,NULL	; 2
	ST Z+,NULL	; 3
	ST Z+,NULL	; 4
	ST Z+,NULL	; 5
	ST Z+,NULL	; 6
	ST Z+,NULL	; 7
	ST Z+,NULL	; 8
	ST Z+,NULL	; 9
	ST Z+,NULL	; 0
	ST Z+,NULL	; 1
	ST Z+,NULL	; 2
	ST Z+,NULL	; 3
	ST Z+,NULL	; 4
	ST Z+,NULL	; 5
	ST Z+,NULL	; 6
	ST Z+,NULL	; 7
	ST Z+,NULL	; 8
	ST Z+,NULL	; 9
	ST Z+,NULL	; 0
	ST Z+,NULL	; 1
	ST Z+,NULL	; 2
	ST Z+,NULL	; 3
	ST Z+,NULL	; 4
	ST Z+,NULL	; 5
	ST Z+,NULL	; 6
	ST Z+,NULL	; 7
	ST Z+,NULL	; 8
	ST Z+,NULL	; 9
	ST Z+,NULL	; 0
	ST Z+,NULL	; 1
	dec temp9
	brne SD_DATA_CLEAR_s
	pop ZH
	pop ZL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SEKTOR_NULL:
	clr SEKTOR0
	clr SEKTOR1
	clr SEKTOR2
	clr SEKTOR3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SEKTOR_PLUS_EINS:
	add SEKTOR0,EINS
	adc SEKTOR1,NULL
	adc SEKTOR2,NULL
	adc SEKTOR3,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SEKTOR_MINUS_EINS:
	sub SEKTOR0,EINS
	sbc SEKTOR1,NULL
	sbc SEKTOR2,NULL
	sbc SEKTOR3,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SEKTOR_NACH_TEMP1_4:
	MOV temp1,SEKTOR0
	MOV temp2,SEKTOR1
	MOV temp3,SEKTOR2
	MOV temp4,SEKTOR3
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMP1_4_NACH_SEKTOR:
	MOV SEKTOR0,temp1
	MOV SEKTOR1,temp2
	MOV SEKTOR2,temp3
	MOV SEKTOR3,temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMP1_2_3_4_MAL_2:
	LSL TEMP1					; x2	
	ROL TEMP2
	ROL TEMP3
	ROL TEMP4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMP1_2_3_4_MAL_512:
	mov temp4,temp3			; 8xlinks		
	mov temp3,temp2
	mov temp2,temp1
	clr temp1				; LOW			

	LSL temp1				; LOW 1xlinks	
	ROL temp2
	ROL temp3
	ROL temp4				; HIGH			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMP1_2_3_4_DURCH_512:
	mov temp1,temp2			; 8xlinks		
	mov temp2,temp3
	mov temp3,temp4
	clr temp4
	LSR TEMP4				; :2	
	ROR TEMP3
	ROR TEMP2
	ROR TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEMP1_2_3_4_DURCH_1000:
	ldi temp5,LOW (1000)
	ldi temp6,HIGH(1000)
	rjmp DIVISION_32_16
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
SD_CSD_CALC:
	rcall SD_CSD_READ				; CSD				
	tst ERROR
	breq SD_CSD_CALC_RUN
	ret
; ------------------------------------------------------------------------------
SD_CSD_CALC_RUN:
	ldi ZL,LOW (adr_SD_DATA+15)		; Initialisierung	
	ldi ZH,HIGH(adr_SD_DATA+15)
; "CSD_STRUCTURE" herausfiltern	[127:126]										
	ldi temp8,126					; START	
	ldi temp9,127					; ENDE	
	rcall SD_SRAM_SELECT_Z_8_9		; temp8=START	temp9=ENDE
	cpi temp1,0						; Version1
	breq SD_CALC_CSD_VERSION1
	cpi temp1,1						; Version2
	breq SD_CSD_V2
ret
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
; "C_SIZE" herausfiltern [69:48]												
; memory capacity = (C_SIZE+1) * 512KByte										
SD_CSD_V2:
	ldi temp8,48						; START	
	ldi temp9,69						; ENDE	
	rcall SD_SRAM_SELECT_Z_8_9	; temp8=START	temp9=ENDE
	; memory capacity = (C_SIZE+1) * 512KByte
	add temp1,EINS
	adc temp2,NULL
	adc temp3,NULL
	adc temp4,NULL
	ldi temp9,9
SD_CALC_CSD_s:
	LSL temp1			; x2
	ROL temp2
	ROL temp3
	ROL temp4
	dec temp9
	brne SD_CALC_CSD_s
; Sectoren													
	rcall TEMP1_2_3_4_MAL_2		; mal 2	
	STS(adr_SD_SEKTOR_MAX0),temp1
	STS(adr_SD_SEKTOR_MAX1),temp2
	STS(adr_SD_SEKTOR_MAX2),temp3
	STS(adr_SD_SEKTOR_MAX3),temp4	
; Capacity													
	rcall TEMP1_2_3_4_DURCH_1000	; durch 1000
	rcall TEMP1_2_3_4_MAL_512	; mal 512	
	rcall TEMP1_2_3_4_DURCH_1000	; durch 1000
	STS(adr_SD_CAPACITY_MB0),temp1
	STS(adr_SD_CAPACITY_MB1),temp2
	STS(adr_SD_CAPACITY_MB2),temp3
	STS(adr_SD_CAPACITY_MB3),temp4	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
; "READ_BL_LEN" herausfiltern [83:80] 4Bit										
SD_CALC_CSD_VERSION1:
	ldi temp8,80						; START	
	ldi temp9,83						; ENDE	
	rcall SD_SRAM_SELECT_Z_8_9		; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_READ_BL_LEN),temp1
; "C_SIZE" herausfiltern [73:62] 12Bit											
	ldi temp8,62						; START	
	ldi temp9,73						; ENDE	
	rcall SD_SRAM_SELECT_Z_8_9		; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_C_SIZE_0),temp1
	STS(adr_SD_CSD_C_SIZE_1),temp2
; "C_SIZE_MULT" herausfiltern [49:47] 											
	ldi temp8,47						; START	
	ldi temp9,49						; ENDE	
	rcall SD_SRAM_SELECT_Z_8_9		; temp8=START	temp9=ENDE
	STS(adr_SD_CSD_C_SIZE_MULT),temp1
; MULT = 2^(C_SIZE_MULT+2) 		(C_SIZE_MULT < 8)	
	mov temp9,temp1
	subi temp9,(-2)		; +2
	ldi temp1,LOW (1)
	ldi temp2,HIGH(1)
SD_CMD9_MU:
	LSL temp1			; links	
	ROL temp2
	dec temp9
	brne SD_CMD9_MU
	STS(adr_SD_CSD_MULT_L),temp1
	STS(adr_SD_CSD_MULT_H),temp2
; memory capacity = BLOCKNR * BLOCK_LEN											
; BLOCKNR = (C_SIZE+1) * MULT													
; MULT = 2^(C_SIZE_MULT+2) 		(C_SIZE_MULT < 8)								
; BLOCK_LEN = 2^(READ_BL_LEN) 	(READ_BL_LEN < 12)								
;																				
	; BLOCKNR = (C_SIZE+1) * MULT												
	LDS temp1,(adr_SD_CSD_C_SIZE_0)
	LDS temp2,(adr_SD_CSD_C_SIZE_1)
	add temp1,EINS
	adc temp2,NULL
	LDS temp3,(adr_SD_CSD_MULT_L)
	LDS temp4,(adr_SD_CSD_MULT_H)
	rcall MULTIPLIKATION_16_16_32
	; BLOCK_LEN = 2^(READ_BL_LEN) 	(READ_BL_LEN < 12)
	LDS temp9,(adr_SD_CSD_READ_BL_LEN)
SD_CMD9_BL:
	LSL temp1			; links	
	ROL temp2
	ROL temp3
	ROL temp4
	dec temp9
	brne SD_CMD9_BL
; Sectoren													
	push temp1
	push temp2
	push temp3
	push temp4
	rcall TEMP1_2_3_4_DURCH_512	; :512	
	sub temp1,EINS				; -1	
	sbc temp2,NULL
	sbc temp3,NULL
	sbc temp4,NULL
	STS(adr_SD_SEKTOR_MAX0),temp1
	STS(adr_SD_SEKTOR_MAX1),temp2
	STS(adr_SD_SEKTOR_MAX2),temp3
	STS(adr_SD_SEKTOR_MAX3),temp4	
	pop temp4
	pop temp3
	pop temp2
	pop temp1
; Capacity													
	rcall TEMP1_2_3_4_DURCH_1000	; durch 1000
	rcall TEMP1_2_3_4_DURCH_1000	; durch 1000
	STS(adr_SD_CAPACITY_MB0),temp1
	STS(adr_SD_CAPACITY_MB1),temp2
	STS(adr_SD_CAPACITY_MB2),temp3
	STS(adr_SD_CAPACITY_MB3),temp4	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; inp: 		temp8 		(BIT-START)												
; inp; 		temp9		(BIT_ENDE)												
; ZL/ZH:	SRAM																
; OUT: 		temp1..5															
; Hilfsregister: R0, R1															
SD_SRAM_SELECT_Z_8_9:
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	clr temp5
	ldi temp,0b10000000
	mov R1,temp			; Hilfsregister	
	inc temp9
	sub temp9,temp8		; Schleife		
SD_SRAM_s:
	mov temp,temp8		; (BIT-NR)		
	andi temp,0b11111000
	LSR temp			; rechts ohne C	
	LSR temp
	LSR temp
	push ZL				; Z sichern		
	push ZH
	sub ZL,temp			; subtrahieren	
	sbc ZH,NULL
	LD R0,Z				; load			
	pop ZH				; Z wiederherstellen
	pop ZL
; ------------------------------------------------------------------------------
	mov temp,temp8		; (BIT-NR)			
	andi temp,0b00000111
	cpi temp,0
	breq SD_SRAM0
	cpi temp,1
	breq SD_SRAM1
	cpi temp,2
	breq SD_SRAM2
	cpi temp,3
	breq SD_SRAM3
	cpi temp,4
	breq SD_SRAM4
	cpi temp,5
	breq SD_SRAM5
	cpi temp,6
	breq SD_SRAM6
	rjmp SD_SRAM7
; ------------------------------------------------------------------------------
SD_SRAM0:
	CLC				; Clear C	
	SBRC R0,0
	SEC 			; Set C		
	rjmp SD_SRAM_w
SD_SRAM1:
	CLC				; Clear C	
	SBRC R0,1
	SEC 			; Set C		
	rjmp SD_SRAM_w
SD_SRAM2:
	CLC				; Clear C	
	SBRC R0,2
	SEC 			; Set C		
	rjmp SD_SRAM_w
SD_SRAM3:
	CLC				; Clear C	
	SBRC R0,3
	SEC 			; Set C		
	rjmp SD_SRAM_w
SD_SRAM4:
	CLC				; Clear C	
	SBRC R0,4
	SEC 			; Set C		
	rjmp SD_SRAM_w
SD_SRAM5:
	CLC				; Clear C	
	SBRC R0,5
	SEC 			; Set C		
	rjmp SD_SRAM_w
SD_SRAM6:
	CLC				; Clear C	
	SBRC R0,6
	SEC 			; Set C		
	rjmp SD_SRAM_w
SD_SRAM7:
	CLC				; Clear C	
	SBRC R0,7
	SEC 			; Set C		
	rjmp SD_SRAM_w
SD_SRAM_w:
	rcall SD_SRAM_C	; rechts ber C
	inc temp8		; (BIT-NR)	
	dec temp9		; Schleife	
	breq SD_SRAM_w2
	rjmp SD_SRAM_s
; ------------------------------------------------------------------------------
SD_SRAM_w2:
	SBRC temp1,0	
	rjmp SD_SRAM_w3
	CLC				; Clear C	
	rcall SD_SRAM_C	; rechts ber C
	rjmp SD_SRAM_w2
; ------------------------------------------------------------------------------
SD_SRAM_w3:
	CLC				; Clear C	
	rcall SD_SRAM_C	; rechts ber C
	ret
; ------------------------------------------------------------------------------
SD_SRAM_C:
	ROR R1			; rechts ber C
	ROR temp5
	ROR temp4
	ROR temp3
	ROR temp2
	ROR temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
