; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; 255				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; ZEIT 				
	ldi temp1,0
	ldi temp2,0
	ldi temp3,0
	STS(adr_hh),temp1
	STS(adr_mm),temp2
	STS(adr_ss),temp3
	; DATUM				
	ldi temp1,1
	ldi temp2,1
	ldi temp3,18
	STS(adr_TAG),  temp1
	STS(adr_MONAT),temp2
	STS(adr_JAHR), temp3
	STS(adr_WOCHENTAG),EINS

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Watchdog aktivieren (max. Zeit)												
WDR_INITIALISIERUNG:
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_NEUSTART:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_s
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_s:
	rjmp NEUSTART_MIT_WDR_s
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PORT B+C+D CLEAR																
PORT_CLEAR:
	ldi temp, 0b00000000	
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL	
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS	
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL	
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
; ------------------------------------------------------------------------------
PROGRAMM_CHECK_FEHLER:
	LED_ROT_ON
	LED_GELB_ON
	LED_GRUEN_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GRUEN_OFF
	rcall WAIT_100ms
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	; auf AUSGANG								
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN		
	sbi (LED_GELB_DDR) ,(LED_GELB_PIN_NR)		; GELB		
	sbi (LED_ROT_DDR)  ,(LED_ROT_PIN_NR)		; ROT		
	sbi (BEEP_DDR)     ,(BEEP_PIN_NR)			; BEEP		
; ------------------------------------------------------------------------------
	BEEP_OFF
	LED_GRUEN_ON
	LED_GELB_ON
	LED_ROT_ON
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_TEST:
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_OFF
	rcall wait_100ms
	LED_GRUEN_ON
	rcall wait_100ms
	LED_GRUEN_OFF
	LED_GELB_ON
	rcall wait_100ms
	LED_GELB_OFF
	LED_ROT_ON
	rcall wait_100ms
	LED_ROT_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_ROT_BLINKT:

	rcall WAIT_100ms
	rcall TASTEN_ABFRAGE	
	rjmp LED_ROT_BLINKT
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_STOP:


	rjmp PROGRAMM_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_TASTE:
	cbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP an	
	rcall wait_20ms
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP  aus	
ret
; ##############################################################################
BEEP_KURZ:
	cbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP an	
	rcall wait_20ms
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP  aus	
	rjmp wait_100ms
; ##############################################################################
BEEP_LANG:
	cbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP an	
	rcall wait_200ms
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; BEEP  aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
STOPPUHR_NULL:
	STS(adr_SU_ss10),NULL
	STS(adr_SU_ss),NULL
	STS(adr_SU_mm),NULL
	STS(adr_SU_hh),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 14.11.2014																	
;																						
; 	INPUT:	TEMP1 / TEMP2 	1.Faktor													
;			TEMP3 / TEMP4	2.Faktor													
; 																						
; 	OUTPUT: TEMP1...4	Produkt															
; 																						
;	HILFSREGISTER: 	temp5+6+7+8 (werden gesichert)										
; 																						
MULTIPLIKATION_16_16_32:
	push temp5
	push temp6
	push temp7
	push temp8

	clr	r2
	mul	temp4,temp2		; ah * bh
	mov	temp7,r0
	mov	temp8,r1
	mul	temp3,temp1		; al * bl
	mov	temp5,r0
	mov	temp6,r1
	mul	temp4,temp1		; ah * bl
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2
	mul	temp2,temp3		; bh * al
	add	temp6,r0
	adc	temp7,r1
	adc	temp8,r2


	mov temp1,temp5
	mov temp2,temp6
	mov temp3,temp7
	mov temp4,temp8

	pop temp8
	pop temp7
	pop temp6
	pop temp5

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 11/2018																
;																				
;	Division 32 bit-Zahl durch 16 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)	(0...4.294.967.295)								
;	input/Output 	temp2														
;	input/Output 	temp3														
;	input/Output 	temp4 (HIGH)												
;																				
;	input	temp5	Divisor	(LOW)	 											
;	input	temp6	Divisor	(HIGH)	 											
;																				
; Register:	R0+R1	Hilfsregister 												
;			temp	Hilfsregister 												
;																				
DIVISION_32_16:
	; Fehlerprfung		
	tst temp5
	brne DIVISION_32_16_RUN
	tst temp6
	brne DIVISION_32_16_RUN
	; Fehler NULL		
	clr temp1
	clr temp2
	clr temp3
	clr temp4
	ret	
;-------------------------------------------------------------------------------
DIVISION_32_16_RUN:
	; RUNDEN halben Divisor dazuaddieren
	mov R0,temp5		; KOPIE			
	mov R1,temp6
	LSR R1				; durch 2		
	ROR r0
	add temp1,R0		; addieren		
	adc temp2,R1
	adc temp3,NULL
	adc temp4,NULL
;-------------------------------------------------------------------------------
	ldi     temp,32    ;32* schieben	
    clr     R0          ;Rest =0		
    clr     R1
DIVISION_32_16_1:    
	lsl     temp1       ;Ein Bit aus dem Dividend ...   
    rol     temp2       ;ins Carry schieben
    rol     temp3
    rol     temp4
    rol     R0          ;Carry in den Rest schieben
    rol     R1
    brcs    DIVISION_32_16_3       ;Bei berlauf von Rest, Sprung
    cp      R0,temp5       					;Solange Bits in temp1 (Rest) schieben bis >= divisor
    cpc     R1,temp6
    brcs    DIVISION_32_16_2    	;Bei Rest<Divisor, die eingeschobene 0 in temp1 stehen lassen
DIVISION_32_16_3:
    inc     temp1       ;Ansonsten Bit0 setzen und den Divisor vom Rest abziehen
    sub     R0,temp5
    sbc     R1,temp6
DIVISION_32_16_2:
   	dec     temp       ;Das ganze 32 mal
    brne    DIVISION_32_16_1
ret 
; ##############################################################################
; ##############################################################################
; ##############################################################################


