;															
; ATmega8													
; Bernhard.Erfurt@gmx.de									
; 11/2019													
;															

;															
; LED GRN: OK												
; LED gelb: SPI Aktivitt									
; LED ROT:	ERROR											
;															

;															
; LED blinken:												
; ROT: 			Interrupt-Error								
; ROT+GELB+GRN:Programm-Error								
;															

; ATmega8 										
.include "m8def.inc"
.include "MACROS.asm"
; KONSTANTEN									
.equ CPU_TAKT				= 16000000			; 16 MHz	
.equ PWM					= OCR1AL
; ERROR CODE									
.equ ERROR_SD_STATUS				= 0xE0
.equ ERROR_SD_CID					= 0xE1
.equ ERROR_SD_READ					= 0xEE
.equ ERROR_SD_READ_MULTIPLE			= 0xEF
.equ ERROR_SD_WRITE_MULTIPLE		= 0xC1
.equ ERROR_SD_WRITE_A				= 0xFA
.equ ERROR_SD_WRITE_B				= 0xFB
.equ ERROR_SD_WRITE_C				= 0xFC
; PWM											
.equ LED_PWM1_PIN_NR		= 1
.equ LED_PWM1_DDR			= DDRB
.equ LED_PWM1_PORT			= PORTB
; SPI-CS										
.equ SPI_CS_PIN_NR			= 2
.equ SPI_CS_DDR				= DDRB
.equ SPI_CS_PORT			= PORTB
; SPI-CS										
.equ SPI_MOSI_PIN_NR		= 3
.equ SPI_MOSI_DDR			= DDRB
.equ SPI_MOSI_PORT			= PORTB
; SPI-CS										
.equ SPI_MISO_PIN_NR		= 4
.equ SPI_MISO_DDR			= DDRB
.equ SPI_MISO_PORT			= PORTB
; SPI-CS										
.equ SPI_SCK_PIN_NR			= 5
.equ SPI_SCK_DDR			= DDRB
.equ SPI_SCK_PORT			= PORTB
; TASTE "A"										
.equ TASTE_A_PIN_NR			= 0
.equ TASTE_A_PIN			= PINC
.equ TASTE_A_DDR			= DDRC
.equ TASTE_A_PORT			= PORTC
.equ TASTE_MENUE_MINUS		= 1
; TASTE "B"										
.equ TASTE_B_PIN_NR			= 1
.equ TASTE_B_PIN			= PINC
.equ TASTE_B_DDR			= DDRC
.equ TASTE_B_PORT			= PORTC
.equ TASTE_MENUE_PLUS		= 2
; TASTE "C"										
.equ TASTE_C_PIN_NR			= 2
.equ TASTE_C_PIN			= PINC
.equ TASTE_C_DDR			= DDRC
.equ TASTE_C_PORT			= PORTC
.equ TASTE_MINUS			= 4
; TASTE "D"										
.equ TASTE_D_PIN_NR			= 3
.equ TASTE_D_PIN			= PINC
.equ TASTE_D_DDR			= DDRC
.equ TASTE_D_PORT			= PORTC
.equ TASTE_PLUS				= 8
; DATA-PIN										
.equ DATA_PIN_NR			= 2
.equ DATA_PIN				= PIND
.equ DATA_DDR				= DDRD
.equ DATA_PORT				= PORTD
; BEEP											
.equ BEEP_PIN_NR			= 4
.equ BEEP_DDR				= DDRD
.equ BEEP_PORT				= PORTD
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR		= 5
.equ LED_GRUEN_DDR			= DDRD
.equ LED_GRUEN_PORT			= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR		= 6
.equ LED_GELB_DDR			= DDRD
.equ LED_GELB_PORT			= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR			= 7
.equ LED_ROT_DDR			= DDRD
.equ LED_ROT_PORT			= PORTD
; LCD (DATA)									
.equ LCD_DATA0_DDR			= DDRC
.equ LCD_DATA1_DDR			= DDRC
.equ LCD_DATA2_DDR			= DDRC
.equ LCD_DATA3_DDR			= DDRC
.equ LCD_DATA0_PORT			= PORTC
.equ LCD_DATA1_PORT			= PORTC
.equ LCD_DATA2_PORT			= PORTC
.equ LCD_DATA3_PORT			= PORTC
.equ LCD_DATA0				= 0
.equ LCD_DATA1				= 1
.equ LCD_DATA2				= 2
.equ LCD_DATA3				= 3
; LCD_ENABLE									
.equ LCD_EN_DDR				= DDRD
.equ LCD_EN_PORT			= PORTD
.equ LCD_EN					= 0
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR				= DDRD
.equ LCD_RS_PORT			= PORTD
.equ LCD_RS					= 1

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						= SRAM_START+0			; START Adresse 	
.equ adr_TASTE						= SRAM_START+1			; Tastaturwert		
.equ adr_MENUE						= SRAM_START+2			; MENUE-AUSWAHL		

.equ adr_ss10						= SRAM_START+10			; Uhr				
.equ adr_ss							= SRAM_START+11
.equ adr_mm							= SRAM_START+12
.equ adr_hh							= SRAM_START+13
.equ adr_TAG						= SRAM_START+14
.equ adr_WOCHENTAG					= SRAM_START+15
.equ adr_MONAT						= SRAM_START+16
.equ adr_JAHR						= SRAM_START+17

.equ adr_SU_ss10					= SRAM_START+20			; Stopuhr			
.equ adr_SU_ss						= SRAM_START+21
.equ adr_SU_mm						= SRAM_START+22
.equ adr_SU_hh						= SRAM_START+23

.equ adr_SD_SEKTOR_MAX0				= SRAM_START+30		; Sekector max		
.equ adr_SD_SEKTOR_MAX1				= SRAM_START+31		; Sekector max		
.equ adr_SD_SEKTOR_MAX2				= SRAM_START+32		; Sekector max		
.equ adr_SD_SEKTOR_MAX3				= SRAM_START+33		; Sekector max		

.equ adr_SD_CAPACITY_MB0			= SRAM_START+34		; Capacity in MB	
.equ adr_SD_CAPACITY_MB1			= SRAM_START+35		; Capacity in MB	
.equ adr_SD_CAPACITY_MB2			= SRAM_START+36		; Capacity in MB	
.equ adr_SD_CAPACITY_MB3			= SRAM_START+37		; Capacity in MB	

.equ adr_SD_SDHC_AKTIV				= SRAM_START+40		; 0=SDSC 1=SDHC					
.equ adr_SD_CSD_READ_BL_LEN			= SRAM_START+41 	; Register CSD =>READ_BL_LEN	
.equ adr_SD_CSD_C_SIZE_0			= SRAM_START+42		; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_1			= SRAM_START+43		; Register CSD =>C_SIZE			
.equ adr_SD_CSD_C_SIZE_MULT			= SRAM_START+44 	; Register CSD =>C_SIZE_MULT	
.equ adr_SD_CSD_MULT_L				= SRAM_START+45
.equ adr_SD_CSD_MULT_H				= SRAM_START+46

.equ adr_SD_PNM1					= SRAM_START+50		; Product name PNM				
.equ adr_SD_PNM2					= SRAM_START+51
.equ adr_SD_PNM3					= SRAM_START+52
.equ adr_SD_PNM4					= SRAM_START+53
.equ adr_SD_PNM5					= SRAM_START+54
.equ adr_SD_MDT						= SRAM_START+55		; Manufacturing date
.equ adr_SD_PSN0					= SRAM_START+56		; Product serial number			
.equ adr_SD_PSN1					= SRAM_START+57
.equ adr_SD_PSN2					= SRAM_START+58
.equ adr_SD_PSN3					= SRAM_START+59

.equ adr_SERIELL_RESET				= SRAM_START+100 
.equ adr_SERIELL_BIT				= SRAM_START+101 
.equ adr_SERIELL_BYTE				= SRAM_START+102 
.equ adr_SERIELL_DATA				= SRAM_START+103 

.equ adr_SD_DATA					= SRAM_START+200	; 512 DATENBYTES 				

.equ adr_SRAM_CHECK					= SRAM_START+900	; SRAM CHECK muss immer "S" sein
; REGISTER										
.def SEKTOR0			= R4
.def SEKTOR1			= R5
.def SEKTOR2			= R6
.def SEKTOR3			= R7

.def ERROR				= R12

.def NULL 				= R13
.def EINS			 	= R14
.def VOLL 			  	= R15

.def temp 				= R16
.def temp1 				= R17
.def temp2 				= R18
.def temp3 				= R19
.def temp4 				= R20
.def temp5 				= R21
.def temp6 				= R22
.def temp7 				= R23
.def temp8 				= R24
.def temp9 				= R25


.cseg					;Beginn eines Code-Segmentes	
.org 0					;Startadresse=0					
rjmp RESET      		; Reset Handler                           				
rjmp EXT_INT0   ; IRQ0 Handler                      							
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	LED_GRUEN_OFF
	LED_GELB_OFF
	LED_ROT_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	rcall WAIT_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
	ldi temp, LOW(RAMEND)				; STACK initialisieren			
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall SRAM_CLEAR					; SRAM-CLEAR					
	rcall PORT_CLEAR					; PORT-CLEAR					
	rcall LED_INITIALISIERUNG			; LED							
	rcall LCD_INITIALISIERUNG			; LCD							
	rcall ANZEIGE_BEGRUESSUNG			; LCD							
	rcall WDR_INITIALISIERUNG			; WDR							
	rcall WDR_NEUSTART					; WDR-NEUSTART					
	rcall STARTWERTE					; STARTWERTE					
	rcall LED_TEST						; LED-TEST						
	rcall SPI_INITIALISIERUNG			; SPI							
	rcall TIMER1_PWM_INITIALISIERUNG	; TIMER1						
	rcall INT_SLEEP_INITIALISIEREN		; ext. Interrupt				
	rcall INT_AKTIVIEREN				; ext. Interrupt				
	rcall AUDIO_ADC_INITIALISIERUNG		; ADC							
	rcall PROGRAMM_CHECK				; PROGRAMM_CHECK				
;-------------------------------------------------------------------------------
	SEI									; Interrupts freigeben			
	rcall LCD_CLEAR	
	rcall SD_INITIALISIERUNG_START
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall SD_CHECK
	rcall TASTEN_ABFRAGE
	rcall MENUE
	rcall PROGRAMM_CHECK			; PROGRAMM_CHECK				
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "SONSTIGES.asm"
.include "MENUE.asm"
.include "LCD.asm"
.include "LCD_ANZEIGE.asm"
.include "LCD_TEXTE.asm"
.include "LCD_ZAHL.asm"
.include "LCD_ASCII.asm"
.include "SPI.asm"
.include "SD.asm"
.include "AUDIO.asm"
.include "TIMER.asm"
.include "INT.asm"
.include "TASTEN.asm"
.include "WAIT.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_11:
.db "AUDIO Sampl: 38kHz ",0
TEXT_BEGRUESSUNG_12:
.db "ATmega8 16MHz",0
TEXT_BEGRUESSUNG_13:
.db "LCD4x20",0
TEXT_BEGRUESSUNG_14:
.db "11/2019",0

